import { Form, serverQrl } from "@builder.io/qwik-city";
import { componentQrl, inlinedQrl, _jsxQ, _fnSignal, _jsxC, Slot, _IMMUTABLE, _jsxBranch, useSignal, Fragment, Resource, _wrapSignal, useLexicalScope } from "@builder.io/qwik";
import { Fragment as Fragment$1 } from "@builder.io/qwik/jsx-runtime";
import { twMerge } from "tailwind-merge";
import { LuChevronLeft, LuChevronRight } from "@qwikest/icons/lucide";
let nanoid = (size = 21) => crypto.getRandomValues(new Uint8Array(size)).reduce((id, byte) => {
  byte &= 63;
  if (byte < 36) {
    id += byte.toString(36);
  } else if (byte < 62) {
    id += (byte - 26).toString(36).toUpperCase();
  } else if (byte > 62) {
    id += "-";
  } else {
    id += "_";
  }
  return id;
}, "");
const QId = (id) => id || nanoid();
const QRest = (reset, form) => Boolean(reset && form && form.value && form.value.statusCode && (form.value.statusCode == 200 || form.value.statusCode == 201));
const QError = (error, form, name) => String(error || form && form.value && form.value.fieldErrors && form.value.fieldErrors[name || ""] || "");
const QValue = (value, form, name) => String(value || form && form.formData && form.formData.get(name || "") || "");
const QInput = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  const QID = QId(props.id);
  const QNAME = props.name || QID;
  const QTYPE = props.type || "text";
  const QERROR = QError(props.error, props.form, QNAME);
  const QAUTOCOMPLETE = props.autoComplete || "off";
  const QRESET = QRest(props.reset, props.form);
  const QVALUE = QRESET ? "" : QValue(props.value, props.form, QNAME);
  const QRUNNING = !!(props.form && props.form.isRunning);
  const QREADONLY = QRUNNING || props.readOnly;
  return /* @__PURE__ */ _jsxQ("div", {
    class: twMerge([
      "mb-4",
      props.class
    ])
  }, null, [
    /* @__PURE__ */ _jsxQ("div", {
      class: `${QREADONLY && "pointer-events-none cursor-wait"} relative`
    }, null, [
      /* @__PURE__ */ _jsxQ("input", {
        autoComplete: QAUTOCOMPLETE,
        class: [
          QERROR ? "border-red-300" : "border-gray-300",
          props.disabled ? "cursor-default opacity-70" : "",
          "peer block w-full appearance-none rounded border bg-transparent  pb-2 pl-3  pr-6 pt-6 text-base text-gray-900 autofill:bg-transparent focus:border-indigo-600 focus:outline-none focus:ring-0 "
        ],
        id: QID,
        name: QNAME,
        onChange$: props.onChange$,
        onInput$: props.onInput$,
        readOnly: QREADONLY,
        type: QTYPE,
        value: QVALUE
      }, {
        disabled: _fnSignal((p0) => p0.disabled, [
          props
        ], "p0.disabled"),
        pattern: _fnSignal((p0) => p0.pattern, [
          props
        ], "p0.pattern"),
        placeholder: " "
      }, null, 2, null),
      /* @__PURE__ */ _jsxQ("label", {
        for: QID
      }, {
        class: "pointer-events-none absolute start-1 top-5 z-10 origin-[0] -translate-y-4 transform select-none px-2 text-sm font-medium text-gray-500 duration-300  peer-placeholder-shown:top-1/2  peer-placeholder-shown:-translate-y-1/2  peer-placeholder-shown:text-base  peer-focus:left-auto  peer-focus:start-1  peer-focus:top-5  peer-focus:-translate-y-4 peer-focus:px-2 peer-focus:text-sm peer-focus:text-indigo-600 "
      }, _fnSignal((p0) => p0.label, [
        props
      ], "p0.label"), 3, null)
    ], 1, null),
    !!QERROR && /* @__PURE__ */ _jsxQ("div", null, {
      class: "text-sm font-medium text-red-600"
    }, QERROR, 1, "wb_0")
  ], 1, "wb_1");
}, "QInput_component_ybvzjHgkWn0"));
const QHiddenInput = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  return /* @__PURE__ */ _jsxQ("input", null, {
    name: _fnSignal((p0) => p0.name, [
      props
    ], "p0.name"),
    type: "hidden",
    value: _fnSignal((p0) => p0.value, [
      props
    ], "p0.value")
  }, null, 3, "wb_2");
}, "QHiddenInput_component_h70NuBrSNRQ"));
const QSelect = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  const QID = QId(props.id);
  const QNAME = props.name || QID;
  const QERROR = QError(props.error, props.form, QNAME);
  const QRESET = QRest(props.reset, props.form);
  const QVALUE = QRESET ? "" : QValue(props.value, props.form, QNAME);
  const QRUNNING = !!(props.form && props.form.isRunning);
  const QDISABLED = QRUNNING || props.disabled;
  return /* @__PURE__ */ _jsxQ("div", {
    class: `${QDISABLED && "pointer-events-none cursor-wait"} relative mb-4`
  }, null, [
    /* @__PURE__ */ _jsxQ("label", {
      for: QID
    }, {
      class: "pointer-events-none absolute start-1 top-5 z-10 origin-[0] -translate-y-4 transform px-2 text-sm font-medium text-gray-500 duration-300  peer-placeholder-shown:top-1/2  peer-placeholder-shown:-translate-y-1/2  peer-placeholder-shown:text-base  peer-focus:left-auto  peer-focus:start-1  peer-focus:top-5  peer-focus:-translate-y-4 peer-focus:px-2 peer-focus:text-sm peer-focus:text-indigo-600 "
    }, _fnSignal((p0) => p0.label, [
      props
    ], "p0.label"), 3, null),
    /* @__PURE__ */ _jsxQ("select", {
      disabled: QDISABLED,
      id: QID,
      name: QNAME,
      onChange$: props.onChange$,
      onInput$: props.onInput$
    }, {
      class: "peer block w-full appearance-none rounded border border-gray-300 bg-transparent pb-2  pl-3 pr-6 pt-6 text-base text-gray-900 focus:border-indigo-600 focus:outline-none focus:ring-0 "
    }, props.options && props.options.map(({ label, value }) => /* @__PURE__ */ _jsxQ("option", {
      selected: QVALUE === (value || label),
      value: value || label
    }, null, label, 1, (value || label) + QID + QNAME)), 0, null),
    !!QERROR && /* @__PURE__ */ _jsxQ("div", null, {
      class: "text-sm font-medium text-red-600"
    }, QERROR, 1, "wb_3")
  ], 1, "wb_4");
}, "QSelect_component_8wgDSRMFano"));
const QButton = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  const QRUNNING = !!(props.form && props.form.isRunning);
  return /* @__PURE__ */ _jsxQ("button", {
    class: `${QRUNNING ? "cursor-not-allowed opacity-90" : "cursor-pointer hover:bg-indigo-700"} relative flex w-full items-center  justify-center rounded bg-indigo-600 py-2 text-center text-base text-white`,
    type: QRUNNING ? "button" : "submit"
  }, null, [
    /* @__PURE__ */ _jsxQ("span", {
      class: `${QRUNNING && "hidden"} absolute left-0 top-0 flex h-full w-full items-center justify-center`
    }, null, [
      "Loading",
      /* @__PURE__ */ _jsxC(QSpinner, null, 3, "wb_5")
    ], 1, null),
    /* @__PURE__ */ _jsxQ("span", {
      class: `${QRUNNING && "opacity-0"} left-0 top-0 flex h-full w-full items-center justify-center`
    }, null, /* @__PURE__ */ _jsxC(Slot, null, 3, "wb_6"), 1, null)
  ], 1, "wb_7");
}, "QButton_component_5KtvC0vuXcU"));
const QSpinner = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  return /* @__PURE__ */ _jsxQ("svg", {
    class: twMerge([
      "ml-2 h-4 w-4",
      props.class
    ])
  }, {
    height: "32",
    viewBox: "0 0 24 24",
    width: "32",
    xmlns: "http://www.w3.org/2000/svg"
  }, /* @__PURE__ */ _jsxQ("g", null, null, [
    /* @__PURE__ */ _jsxQ("circle", null, {
      cx: "12",
      cy: "2.5",
      fill: "currentColor",
      opacity: ".14",
      r: "1.5"
    }, null, 3, null),
    /* @__PURE__ */ _jsxQ("circle", null, {
      cx: "16.75",
      cy: "3.77",
      fill: "currentColor",
      opacity: ".29",
      r: "1.5"
    }, null, 3, null),
    /* @__PURE__ */ _jsxQ("circle", null, {
      cx: "20.23",
      cy: "7.25",
      fill: "currentColor",
      opacity: ".43",
      r: "1.5"
    }, null, 3, null),
    /* @__PURE__ */ _jsxQ("circle", null, {
      cx: "21.5",
      cy: "12",
      fill: "currentColor",
      opacity: ".57",
      r: "1.5"
    }, null, 3, null),
    /* @__PURE__ */ _jsxQ("circle", null, {
      cx: "20.23",
      cy: "16.75",
      fill: "currentColor",
      opacity: ".71",
      r: "1.5"
    }, null, 3, null),
    /* @__PURE__ */ _jsxQ("circle", null, {
      cx: "16.75",
      cy: "20.23",
      fill: "currentColor",
      opacity: ".86",
      r: "1.5"
    }, null, 3, null),
    /* @__PURE__ */ _jsxQ("circle", null, {
      cx: "12",
      cy: "21.5",
      fill: "currentColor",
      r: "1.5"
    }, null, 3, null),
    /* @__PURE__ */ _jsxQ("animateTransform", null, {
      attributeName: "transform",
      calcMode: "discrete",
      dur: "0.75s",
      repeatCount: "indefinite",
      type: "rotate",
      values: "0 12 12;30 12 12;60 12 12;90 12 12;120 12 12;150 12 12;180 12 12;210 12 12;240 12 12;270 12 12;300 12 12;330 12 12;360 12 12"
    }, null, 3, null)
  ], 3, null), 3, "wb_8");
}, "QSpinner_component_a4xj3J8HxZE"));
const QForm = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  const QRUNNING = !!(props.action && props.action.isRunning);
  return /* @__PURE__ */ _jsxC(Form, {
    get action() {
      return props.action;
    },
    children: /* @__PURE__ */ _jsxC(Slot, null, 3, "wb_9"),
    class: twMerge([
      `${QRUNNING && "pointer-events-none cursor-progress opacity-75"} mx-auto w-[600px] max-w-full bg-white p-8 shadow`,
      props.class
    ]),
    [_IMMUTABLE]: {
      action: _fnSignal((p0) => p0.action, [
        props
      ], "p0.action")
    }
  }, 1, "wb_10");
}, "QForm_component_VWMss10ujH4"));
const QInputSm = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  _jsxBranch();
  const QID = QId(props.id);
  const QNAME = props.name || QID;
  const QTYPE = props.type || "text";
  const QERROR = QError(props.error, props.form, QNAME);
  const QAUTOCOMPLETE = props.autoComplete || "off";
  const QDISABLED = props.disabled || false;
  const QRESET = QRest(props.reset, props.form);
  const QVALUE = QRESET ? "" : QValue(props.value, props.form, QNAME);
  const QRUNNING = !!(props.form && props.form.isRunning);
  const QREADONLY = QRUNNING || props.readOnly || false;
  return /* @__PURE__ */ _jsxQ("div", {
    class: twMerge([
      `${QREADONLY && "pointer-events-none cursor-wait opacity-75"} relative mb-4`,
      props.class
    ])
  }, null, [
    /* @__PURE__ */ _jsxQ("input", {
      autoComplete: QAUTOCOMPLETE,
      class: `peer block w-full appearance-none rounded border bg-transparent  pb-2 pl-3  pr-6 pt-6 text-base text-gray-900 autofill:bg-transparent focus:border-indigo-600 focus:outline-none focus:ring-0 ${QERROR ? "border-red-300" : "border-gray-300"} ${QDISABLED && "cursor-default opacity-70"}`,
      disabled: QDISABLED,
      id: QID,
      name: QNAME,
      onChange$: props.onChange$,
      onInput$: props.onInput$,
      readOnly: QREADONLY,
      type: QTYPE,
      value: QVALUE
    }, {
      pattern: _fnSignal((p0) => p0.pattern, [
        props
      ], "p0.pattern")
    }, null, 2, null),
    /* @__PURE__ */ _jsxQ("label", {
      for: QID
    }, {
      class: "pointer-events-none absolute  start-1 top-1 z-10 origin-[0] -translate-y-4 scale-75 transform select-none bg-white px-2 text-base text-gray-500 duration-300 peer-placeholder-shown:top-1/2 peer-placeholder-shown:-translate-y-1/2 peer-placeholder-shown:scale-100"
    }, _fnSignal((p0) => p0.label, [
      props
    ], "p0.label"), 3, null),
    !!props.button && /* @__PURE__ */ _jsxQ("button", {
      class: `${QRUNNING ? "cursor-not-allowed opacity-90" : "cursor-pointer hover:bg-indigo-700"} absolute bottom-[3px] end-[3px] rounded bg-indigo-600 px-4  py-2 text-sm font-medium text-white`,
      onClick$: props.onClick$,
      type: QRUNNING ? "button" : "submit"
    }, null, [
      /* @__PURE__ */ _jsxQ("span", {
        class: `${QRUNNING ? "absolute" : "hidden"} left-0 top-0 flex h-full w-full items-center justify-center`
      }, null, /* @__PURE__ */ _jsxC(QSpinner, {
        class: "ml-0",
        [_IMMUTABLE]: {
          class: _IMMUTABLE
        }
      }, 3, "wb_11"), 1, null),
      /* @__PURE__ */ _jsxQ("span", {
        class: `${QRUNNING && "opacity-0"} left-0 top-0 flex h-full w-full items-center justify-center`
      }, null, _fnSignal((p0) => p0.button, [
        props
      ], "p0.button"), 3, null)
    ], 0, "wb_12")
  ], 1, "wb_13");
}, "QInputSm_component_fluHgk9ZkA0"));
const QTextarea = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  const QID = QId(props.id);
  const QNAME = props.name || QID;
  const QERROR = QError(props.error, props.form, QNAME);
  const QDISABLED = props.disabled || false;
  const QRESET = QRest(props.reset, props.form);
  const QVALUE = QRESET ? "" : QValue(props.value, props.form, QNAME);
  const QRUNNING = !!(props.form && props.form.isRunning);
  const QREADONLY = QRUNNING || props.readOnly || false;
  return /* @__PURE__ */ _jsxQ("div", {
    class: twMerge([
      "mb-4",
      props.class
    ])
  }, null, [
    /* @__PURE__ */ _jsxQ("div", null, {
      class: "relative"
    }, [
      /* @__PURE__ */ _jsxQ("textarea", {
        class: `peer block w-full appearance-none rounded border bg-transparent  pb-2 pl-3  pr-6 pt-6 text-base text-gray-900 autofill:bg-transparent focus:border-indigo-600 focus:outline-none focus:ring-0 ${QERROR ? "border-red-300" : "border-gray-300"}`,
        defaultValue: QVALUE,
        disabled: QDISABLED,
        id: QID,
        name: QNAME,
        readOnly: QREADONLY,
        value: QVALUE
      }, {
        placeholder: " "
      }, null, 3, null),
      /* @__PURE__ */ _jsxQ("label", {
        for: QID
      }, {
        class: "pointer-events-none absolute start-1 top-5 z-10 origin-[0] -translate-y-4 transform select-none px-2 text-sm font-medium text-gray-500 duration-300  peer-placeholder-shown:top-1/2  peer-placeholder-shown:-translate-y-1/2  peer-placeholder-shown:text-base  peer-focus:left-auto  peer-focus:start-1  peer-focus:top-5  peer-focus:-translate-y-4 peer-focus:px-2 peer-focus:text-sm peer-focus:text-indigo-600 "
      }, _fnSignal((p0) => p0.label, [
        props
      ], "p0.label"), 3, null)
    ], 1, null),
    !!QERROR && /* @__PURE__ */ _jsxQ("div", null, {
      class: "text-sm font-medium text-red-600"
    }, QERROR, 1, "wb_14")
  ], 1, "wb_15");
}, "QTextarea_component_Jq77HVkbcbo"));
const QModal = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  const QELEMENT = useSignal();
  const QVSIGNAL = props.signal.value;
  const QHIDE = /* @__PURE__ */ inlinedQrl(() => {
    const [props2] = useLexicalScope();
    return props2.signal.value = false;
  }, "QModal_component_QHIDE_OmP61teZsGo", [
    props
  ]);
  const QHANDLER = /* @__PURE__ */ inlinedQrl((ev) => {
    const [QELEMENT2, QHIDE2] = useLexicalScope();
    if (QELEMENT2.value && ev.target && !QELEMENT2.value.contains(ev.target))
      return QHIDE2();
  }, "QModal_component_QHANDLER_SiLZpIHFtiE", [
    QELEMENT,
    QHIDE
  ]);
  return /* @__PURE__ */ _jsxC(Fragment, {
    children: [
      /* @__PURE__ */ _jsxQ("div", {
        class: `fixed inset-0 z-50  bg-black bg-opacity-70 transition-opacity ${!QVSIGNAL && "hidden"}`
      }, null, null, 3, null),
      /* @__PURE__ */ _jsxQ("div", {
        class: `fixed inset-0 z-50 overflow-y-auto ${!QVSIGNAL && "hidden"}`
      }, {
        onClick$: QHANDLER
      }, /* @__PURE__ */ _jsxQ("div", null, {
        class: "flex min-h-full items-baseline justify-center p-4 text-center sm:p-0"
      }, /* @__PURE__ */ _jsxQ("div", {
        ref: QELEMENT
      }, {
        class: "relative transform overflow-hidden border-t-2 border-indigo-500 bg-white p-8 text-left shadow-2xl  sm:my-8 sm:w-full sm:max-w-lg"
      }, [
        /* @__PURE__ */ _jsxQ("div", null, {
          class: "absolute right-0 top-0 cursor-pointer bg-indigo-500 p-1 text-white shadow hover:text-indigo-900",
          onClick$: QHIDE
        }, /* @__PURE__ */ _jsxQ("svg", null, {
          class: "h-5 w-5",
          fill: "none",
          stroke: "currentColor",
          "stroke-width": "1.5",
          type: "button",
          viewBox: "0 0 24 24",
          xmlns: "http://www.w3.org/2000/svg"
        }, /* @__PURE__ */ _jsxQ("path", null, {
          d: "M6 18L18 6M6 6l12 12",
          "stroke-linecap": "round",
          "stroke-linejoin": "round"
        }, null, 3, null), 3, null), 3, null),
        /* @__PURE__ */ _jsxC(Slot, null, 3, "wb_16")
      ], 1, null), 1, null), 1, null)
    ]
  }, 1, "wb_17");
}, "QModal_component_YKnAKTeIX5w"));
const QContainer = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  return /* @__PURE__ */ _jsxQ("div", {
    class: twMerge("mb-10 w-full max-w-full bg-white p-8 shadow", props.class)
  }, null, /* @__PURE__ */ _jsxC(Slot, null, 3, "wb_18"), 1, "wb_19");
}, "QContainer_component_QKV3EncqZEk"));
const QPagination = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  return /* @__PURE__ */ _jsxC(Resource, {
    get value() {
      return props.resource;
    },
    onResolved: (e) => {
      if (!e.pagination || !props.page && !e?.signal || !e.pagination.length || e.results.total <= e.results.perPage)
        return /* @__PURE__ */ _jsxC(Fragment$1, null, 3, "wb_20");
      return /* @__PURE__ */ _jsxQ("div", null, {
        class: "flex items-center justify-between border-t border-gray-200 bg-white pt-4 select-none"
      }, /* @__PURE__ */ _jsxQ("div", null, {
        class: "flex-1 items-center justify-between sm:flex"
      }, [
        /* @__PURE__ */ _jsxQ("div", null, {
          class: "hidden sm:block"
        }, /* @__PURE__ */ _jsxQ("p", null, {
          class: "text-sm font-medium text-gray-700"
        }, [
          "Showing ",
          _wrapSignal(e.results, "from"),
          " to ",
          _wrapSignal(e.results, "to"),
          " of ",
          _wrapSignal(e.results, "total"),
          " results"
        ], 1, null), 1, null),
        /* @__PURE__ */ _jsxQ("div", null, null, /* @__PURE__ */ _jsxQ("nav", null, {
          class: "isolate inline-flex -space-x-px rounded-md shadow-sm"
        }, e.pagination.length && e.pagination.map((item) => {
          _jsxBranch();
          const QTEXT = String(item.text);
          const QPAGE = Number(item.page);
          const QSIGNAL = props.page;
          const QACTIVE = Boolean(item.active);
          const QDISABLED = Boolean(item.disabled);
          return /* @__PURE__ */ _jsxQ("span", {
            class: `relative select-none inline-flex items-center px-4 py-2 text-sm font-semibold  ${QDISABLED && "cursor-default text-gray-700 ring-1 ring-inset ring-gray-300 focus:outline-offset-0"} ${QACTIVE && "z-10 cursor-pointer bg-indigo-600 text-white focus:z-20 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-indigo-600"} ${!QACTIVE && !QDISABLED && "cursor-pointer text-gray-900 ring-1 ring-inset ring-gray-300 hover:bg-gray-50 focus:z-20 focus:outline-offset-0"}`,
            onClick$: /* @__PURE__ */ inlinedQrl(() => {
              const [QDISABLED2, QPAGE2, QSIGNAL2] = useLexicalScope();
              return !QDISABLED2 && QSIGNAL2 && (QSIGNAL2.value = QPAGE2);
            }, "QPagination_component_Resource_onResolved_div_div_div_nav_span_onClick_KATZHSno8fU", [
              QDISABLED,
              QPAGE,
              QSIGNAL
            ])
          }, null, [
            QTEXT == "«" && /* @__PURE__ */ _jsxC(LuChevronLeft, {
              class: "h-5 w-5",
              [_IMMUTABLE]: {
                class: _IMMUTABLE
              }
            }, 3, "wb_21"),
            QTEXT == "»" && /* @__PURE__ */ _jsxC(LuChevronRight, {
              class: "h-5 w-5",
              [_IMMUTABLE]: {
                class: _IMMUTABLE
              }
            }, 3, "wb_22"),
            QTEXT != "«" && QTEXT != "»" && QTEXT
          ], 0, `${QTEXT}-${QPAGE}-${QACTIVE}-${QDISABLED}-${Math.random()}`);
        }), 1, null), 1, null)
      ], 1, null), 1, "wb_23");
    },
    [_IMMUTABLE]: {
      onResolved: _IMMUTABLE,
      value: _fnSignal((p0) => p0.resource, [
        props
      ], "p0.resource")
    }
  }, 3, "wb_24");
}, "QPagination_component_EiV3mhtft1o"));
const QTable = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  _jsxBranch();
  return /* @__PURE__ */ _jsxQ("div", null, {
    class: "overflow-x-auto"
  }, /* @__PURE__ */ _jsxQ("table", null, {
    class: "border-ingigo-50 w-full border-collapse border text-center text-base"
  }, [
    props.header && /* @__PURE__ */ _jsxQ("thead", null, null, /* @__PURE__ */ _jsxQ("tr", null, {
      class: "bg-indigo-500 text-white"
    }, props.header.map((item, i) => /* @__PURE__ */ _jsxQ("th", null, {
      class: "border-ingigo-50 border p-2"
    }, item, 1, item + i)), 1, null), 1, "wb_25"),
    /* @__PURE__ */ _jsxQ("tbody", null, null, [
      props.resource && /* @__PURE__ */ _jsxC(Resource, {
        get value() {
          return props.resource;
        },
        onResolved: (e) => /* @__PURE__ */ _jsxBranch(("data" in e && e.data.length === 0 || Object.keys(e).length === 0) && /* @__PURE__ */ _jsxC(QTableRow, {
          children: /* @__PURE__ */ _jsxC(QTableCol, {
            get colSpan() {
              return props.header?.length;
            },
            children: "No data found",
            class: "text-center",
            [_IMMUTABLE]: {
              class: _IMMUTABLE,
              colSpan: _fnSignal((p0) => p0.header?.length, [
                props
              ], "p0.header?.length")
            }
          }, 3, "wb_26")
        }, 1, "wb_27")),
        [_IMMUTABLE]: {
          onResolved: _IMMUTABLE,
          value: _fnSignal((p0) => p0.resource, [
            props
          ], "p0.resource")
        }
      }, 3, "wb_28"),
      /* @__PURE__ */ _jsxC(Slot, null, 3, "wb_29")
    ], 1, null)
  ], 1, null), 1, "wb_30");
}, "QTable_component_BZZkFxV10Cw"));
const QTableRow = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl(() => /* @__PURE__ */ _jsxQ("tr", null, null, /* @__PURE__ */ _jsxC(Slot, null, 3, "wb_31"), 1, "wb_32"), "QTableRow_component_3qOrqr9FcrI"));
const QTableCol = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  return /* @__PURE__ */ _jsxQ("td", {
    class: twMerge([
      "border-ingigo-50 border p-2",
      props.class
    ])
  }, {
    colSpan: _fnSignal((p0) => p0.colSpan, [
      props
    ], "p0.colSpan")
  }, /* @__PURE__ */ _jsxC(Slot, null, 3, "wb_33"), 1, "wb_34");
}, "QTableCol_component_0VR3jZIp4T4"));
async function qfetch(url, request, event) {
  const { headers, ...rest } = request || {};
  return fetch(new Request(new URL(url, event?.url), {
    headers: new Headers({
      ...Object.entries(event?.request?.headers || {}),
      cookie: Object.entries(event?.cookie?.getAll() || {}).map(([k, v]) => `${k}=${v.value}`).join("; "),
      ...headers && {
        ...headers
      }
    }),
    ...rest
  }));
}
const QFetch = async (url, request, event) => {
  try {
    const response = await qfetch(url, request, event);
    const json = await response.json();
    const { statusCode, message, setCookies, ...rest } = json;
    if (response.ok && response.status == statusCode) {
      if (event.cookie != void 0 && setCookies && setCookies.length && Array.isArray(setCookies))
        setCookies.forEach((cookie) => {
          const options = cookie.options || {};
          if (event.cookie && event.cookie != void 0)
            event.cookie.set(cookie.name, cookie.value, {
              ...options.maxAge && {
                maxAge: parseInt(options.maxAge, 10)
              },
              ...options.path && {
                path: String(options.path)
              },
              ...options.domain && {
                domain: String(options.domain)
              },
              ...options.secure && {
                secure: Boolean(options.secure)
              },
              ...options.httpOnly && {
                httpOnly: Boolean(options.httpOnly)
              },
              ...options.sameSite && {
                sameSite: String(options.sameSite)
              },
              ...options.expires && {
                expires: new Date(options.expires)
              }
            });
        });
      return {
        statusCode,
        message,
        ...rest
      };
    }
  } catch (error) {
    console.error("qfetch failed: ", error);
  }
  return {
    statusCode: 500,
    message: "Server error"
  };
};
function _QData(url, data) {
  const { body } = "params" in data && "body" in data && typeof data.body === "object" ? data : {
    body: data
  };
  const { params } = "params" in data && "body" in data && typeof data.params === "object" ? data : {
    params: {}
  };
  const qurl = Object.keys(params ?? {}).length ? `${url}?${new URLSearchParams(params)}` : url;
  return {
    body: body || {},
    qurl
  };
}
async function qget(url, data, event, request) {
  const { qurl } = _QData(url, data);
  return QFetch(qurl, {
    ...request,
    method: "GET"
  }, event);
}
async function qpost(url, data, event, request) {
  const { body, qurl } = _QData(url, data);
  return QFetch(qurl, {
    ...request,
    method: "POST",
    body: JSON.stringify(body)
  }, event);
}
async function qput(url, data, event, request) {
  const { body, qurl } = _QData(url, data);
  return QFetch(qurl, {
    ...request,
    method: "PUT",
    body: JSON.stringify(body)
  }, event);
}
async function qdelete(url, data, event, request) {
  const { body, qurl } = _QData(url, data);
  return QFetch(qurl, {
    ...request,
    method: "DELETE",
    body: JSON.stringify(body)
  }, event);
}
async function qpatch(url, data, event, request) {
  const { body, qurl } = _QData(url, data);
  return QFetch(qurl, {
    ...request,
    method: "PATCH",
    body: JSON.stringify(body)
  }, event);
}
const _QFetch = serverQrl(/* @__PURE__ */ inlinedQrl(async function(url, request) {
  return await QFetch(url, request, this);
}, "_QFetch_server_DSJKWSY9vJI"));
async function _qget(url, data, request) {
  const { qurl } = _QData(url, data);
  return _QFetch(qurl, {
    ...request,
    method: "GET"
  });
}
async function _qpost(url, data, request) {
  const { body, qurl } = _QData(url, data);
  return _QFetch(qurl, {
    ...request,
    method: "POST",
    body: JSON.stringify(body)
  });
}
async function _qput(url, data, request) {
  const { body, qurl } = _QData(url, data);
  return _QFetch(qurl, {
    ...request,
    method: "PUT",
    body: JSON.stringify(body)
  });
}
async function _qdelete(url, data, request) {
  const { body, qurl } = _QData(url, data);
  return _QFetch(qurl, {
    ...request,
    method: "DELETE",
    body: JSON.stringify(body)
  });
}
async function _qpatch(url, data, request) {
  const { body, qurl } = _QData(url, data);
  return _QFetch(qurl, {
    ...request,
    method: "PATCH",
    body: JSON.stringify(body)
  });
}
async function _qmget(url, data, request) {
  const { qurl } = _QData(url, data);
  return (await _QFetch(qurl, {
    ...request,
    method: "GET"
  })).message;
}
async function _qsget(url, data, request) {
  const { qurl } = _QData(url, data);
  return Number((await _QFetch(qurl, {
    ...request,
    method: "GET"
  })).statusCode);
}
async function _qdget(url, data, request) {
  const res = await _qmget(url, data, request);
  return {
    pagination: res?.pagination || [],
    results: res?.results || {
      total: res?.results?.total || 0,
      page: res?.results?.page || 0,
      from: res?.results?.from || 0,
      to: res?.results?.to || 0,
      perPage: res?.results?.perPage || 0
    },
    data: res?.data || [],
    signal: {
      value: res?.results?.page || 1
    }
  };
}
const sget = _qget;
const spost = _qpost;
const sput = _qput;
const sdelete = _qdelete;
const spatch = _qpatch;
const smget = _qmget;
const ssget = _qsget;
const sdget = _qdget;
export {
  QButton,
  QContainer,
  QFetch,
  QForm,
  QHiddenInput,
  QInput,
  QInputSm,
  QModal,
  QPagination,
  QSelect,
  QSpinner,
  QTable,
  QTableCol,
  QTableRow,
  QTextarea,
  _QData,
  _QFetch,
  _qdelete,
  _qdget,
  _qget,
  _qmget,
  _qpatch,
  _qpost,
  _qput,
  _qsget,
  qdelete,
  qfetch,
  qget,
  qpatch,
  qpost,
  qput,
  sdelete,
  sdget,
  sget,
  smget,
  spatch,
  spost,
  sput,
  ssget
};
